#!/usr/bin/env python3

books = {}

books['Delitto e castigo'] = "Fedor Dostoevskji"
books['I fratelli Karamazov'] = "Fedor Dostoevskji"
books['Guerra e pace'] = "Lev Tolstoij"

print(set(books.values()))

for author in set(books.values()):
    print(author, list(books.values()).count(author))




print(list(filter(lambda x: 'a' not in x, books.keys())))

print([book for book in books if 'a' not in book])

##############################################

author_count = {}

for book, author in books.items():
    author_count[author] = author_count.get(author, 0) + 1

for author, num_books in author_count.items():
    print(author, num_books)



###############################################

books_r = {}


for book, author in books.items():
    books_r.setdefault(author, []).append(book)


###############################################
print()


for book, author in books.items():
    print("{author} ha scritto il libro {book!r}.".format(
        author=author,
        book=book))
