#!/usr/bin/env python3


class MyRange(object):
    def __init__(self, stop):
        self.stop = stop
        self.current = 0

    def __iter__(self):
        return self

    def __next__(self):
        if self.current >= self.stop:
            raise StopIteration()
        c = self.current
        self.current += 1
        return c



################################################################################


r = MyRange(10)


for i in r:
    for j in r:
        print((i, j))


